searchNodes=[{"doc":"Sleipnir consists of functions to create valid PushRequests to send to Grafana Loki, as well as a protocol for clients and a default implementation thereof for Tesla clients. This gives the user of this library flexibility in which parts they would like to use, as well as a quick way to start sending requests to Loki by using Tesla. Functions generally return the underlying Protobufs: Google.Protobuf.Timestamp : Standard Protobuf for timestamps. Represented as seconds and nanoseconds encoded in Propleptic Gregorian Calendar. The Sleipnir.Timestamp module provides functions for manipulating and creating timestamps from Elixir-native types. Logproto.EntryAdapter : An entry is a log line at a certain time Logproto.StreamAdapter : A stream is a collection of entries under a common set of labels. Logproto.PushRequest : A request is a collection of streams, and can be sent to Grafana Loki.","ref":"Sleipnir.html","title":"Sleipnir","type":"module"},{"doc":"Returns an entry, which is a log line/string at a given time. The timestamp can be of type DateTime, NaiveDateTime, or Google.Protobuf.Timestamp. If no timestamp is provided, the current time is used. entry1 = Sleipnir.entry(&quot;I am a log line&quot;) entry2 = Sleipnir.entry(&quot;I am also a log line&quot;, DateTime.utc_now())","ref":"Sleipnir.html#entry/2","title":"Sleipnir.entry/2","type":"function"},{"doc":"See Sleipnir.Client.push/3 .","ref":"Sleipnir.html#push/3","title":"Sleipnir.push/3","type":"function"},{"doc":"Creates a PushRequest from one or more streams. request = Sleipnir.request(stream)","ref":"Sleipnir.html#request/1","title":"Sleipnir.request/1","type":"function"},{"doc":"A stream consists of one or more entries under a common set of labels. stream = Sleipnir.stream([entry1, entry2], [{&quot;label&quot;, &quot;value&quot;}])","ref":"Sleipnir.html#stream/2","title":"Sleipnir.stream/2","type":"function"},{"doc":"Returns a stream for a single entry from a line and timestamp. To create a stream of multiple entries, take a look at stream/2.","ref":"Sleipnir.html#stream/3","title":"Sleipnir.stream/3","type":"function"},{"doc":"","ref":"Sleipnir.html#t:entry/0","title":"Sleipnir.entry/0","type":"type"},{"doc":"Loki labels are easily represented in Elixir as a list of String tuples. labels = [ { &quot;namespace&quot; , &quot;loki&quot; } , { &quot;region&quot; , &quot;us-east-1&quot; } ]","ref":"Sleipnir.html#t:labels/0","title":"Sleipnir.labels/0","type":"type"},{"doc":"","ref":"Sleipnir.html#t:request/0","title":"Sleipnir.request/0","type":"type"},{"doc":"","ref":"Sleipnir.html#t:stream/0","title":"Sleipnir.stream/0","type":"type"},{"doc":"","ref":"Sleipnir.html#t:timestamp/0","title":"Sleipnir.timestamp/0","type":"type"},{"doc":"The HTTP client that makes requests on behalf of Sleipnir","ref":"Sleipnir.Client.html","title":"Sleipnir.Client","type":"protocol"},{"doc":"Pushes the request to Loki. Implementations may define their own options.","ref":"Sleipnir.Client.html#push/3","title":"Sleipnir.Client.push/3","type":"function"},{"doc":"","ref":"Sleipnir.Client.html#t:reason/0","title":"Sleipnir.Client.reason/0","type":"type"},{"doc":"Returned if the request was successfully sent. Loki will generally respond with status 204 No Content on a successful request. Headers should contain the headers from the response.","ref":"Sleipnir.Client.html#t:response/0","title":"Sleipnir.Client.response/0","type":"type"},{"doc":"","ref":"Sleipnir.Client.html#t:result/0","title":"Sleipnir.Client.result/0","type":"type"},{"doc":"Can be any type that has an implementation for the Sleipnir.Client protocol. Default implementation is provided for Tesla.Client.","ref":"Sleipnir.Client.html#t:t/0","title":"Sleipnir.Client.t/0","type":"type"},{"doc":"Tesla client for Sleipnir.","ref":"Sleipnir.Client.Tesla.html","title":"Sleipnir.Client.Tesla","type":"module"},{"doc":"Returns a Tesla client set up to send logs to Loki. Options :org_id - Must be specified when using Loki in multi-tenancy mode (i.e. auth_enabled is true ). Sets the X-Scope_orgID header accordingly Sets the X-Scope-OrgID header accordingly","ref":"Sleipnir.Client.Tesla.html#new/2","title":"Sleipnir.Client.Tesla.new/2","type":"function"},{"doc":"","ref":"Sleipnir.Client.Tesla.html#t:base_url/0","title":"Sleipnir.Client.Tesla.base_url/0","type":"type"},{"doc":"","ref":"Sleipnir.Client.Tesla.html#t:opts/0","title":"Sleipnir.Client.Tesla.opts/0","type":"type"},{"doc":"A test client that returns what it was sent","ref":"Sleipnir.Client.Test.html","title":"Sleipnir.Client.Test","type":"module"},{"doc":"","ref":"Sleipnir.Client.Test.html#t:t/0","title":"Sleipnir.Client.Test.t/0","type":"type"},{"doc":"Loki API paths","ref":"Sleipnir.Paths.html","title":"Sleipnir.Paths","type":"module"},{"doc":"","ref":"Sleipnir.Paths.html#push/0","title":"Sleipnir.Paths.push/0","type":"function"},{"doc":"Helpers centered around the use of Google.Protobuf.Timestamp","ref":"Sleipnir.Timestamp.html","title":"Sleipnir.Timestamp","type":"module"},{"doc":"","ref":"Sleipnir.Timestamp.html#compare/2","title":"Sleipnir.Timestamp.compare/2","type":"function"},{"doc":"","ref":"Sleipnir.Timestamp.html#from/1","title":"Sleipnir.Timestamp.from/1","type":"function"},{"doc":"See Google.Protobuf.Timestamp.new/0 .","ref":"Sleipnir.Timestamp.html#new/0","title":"Sleipnir.Timestamp.new/0","type":"function"},{"doc":"","ref":"Sleipnir.Timestamp.html#now/0","title":"Sleipnir.Timestamp.now/0","type":"function"},{"doc":"Sleipnir A client for pushing logs to Grafana Loki.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding sleipnir to your list of dependencies in mix.exs : def deps do [ { :sleipnir , &quot;~&gt; 0.1.1&quot; } ] end Documentation may be found at https://hexdocs.pm/sleipnir .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"The Sleipnir module contains functions for creating Loki requests from your data, based on Grafana's protobufs. The important parts are: Entries : timestamped strings Streams : collections of entries under a common set of labels. PushRequests : collections of streams, all pushed to Loki as a single request. Here's an example: entries = [ Sleipnir . entry ( &quot;I am a log line&quot; ) , Sleipnir . entry ( &quot;I am another log line&quot; ) ] labels = [ { &quot;cluster&quot; , &quot;ops-cluster-1&quot; } , { &quot;namespace&quot; , &quot;loki-dev&quot; } ] stream = Sleipnir . stream ( entries , labels ) request = Sleipnir . request ( stream ) To send the requests to Loki, Sleipnir includes a Tesla client that aims to provide sensible defaults. client = Sleipnir.Client.Tesla . new ( &quot;http://localhost:3100&quot; , org_id : &quot;tenant1&quot; ) { :ok , %{ status : 204 } } = Sleipnir . push ( client , request )","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Custom clients can be implemented via the [Sleipnir.Client](lib/sleipnir/client.ex) protocol. A default implementation is provided for the [Tesla.Client](/lib/sleipnir/client/tesla.ex) struct which zips the push request and sends it to the standard /loki/api/v1/push path. Also included is the [Sleipnir.Client.Test client](lib/sleipnir/client/test.ex) which sends any requests pushed to it to the provided pid. Useful for testing without the need for bypass or Tesla.Mock.","ref":"readme.html#customizing-the-client","title":"README - Customizing the Client","type":"extras"}]